!	A GAS 386 backend for T -- Copyright (C) 1997,1998 Nils M. Holm
!	See t.t for details.

const	BPW	=	4;	! bytes per word !
const	PUSHDOWN=	1;	! push-down stack !

const	OBUFL	=	1024;

var	Obuf[OBUFL], Obp;

decl	length(1), newlab(0), strcpy(2);


flush() do
	writes(Obuf);
	Obp := 0;
end


initcg() do
	Obp := 0;
end


endcg() do
	flush();
end


tx(s) do
	var	k;

	k := length(s);
	if (k+Obp >= OBUFL) flush();
	strcpy(@Obuf[Obp], s);
	Obp := Obp + k;
end


pr(s) do
	tx("\t");
	tx(s);
end


nl() tx("\n");

col() tx(":");


totext() do
	pr(".text"); nl();
end


todata() do
	pr(".data"); nl();
end


tobss() do
	pr(".bss"); nl();
end


num(n) do
	tx(ntoa(n, 0));
end


lab(n) do
	tx("_L_"); num(n);
end


push() do
	pr("pushl\t%eax"); nl();
end


pop() do
	pr("popl\t%eax"); nl();
end


cg_pop() pop();


pop2() do
	pr("popl\t%ecx"); nl();
end


cg_extdecl(s) ;


cg_globdecl(s, l, z) do
	tobss();
	pr(".align\t2"); nl();
	ie (z) do
		pr(".comm\t"); tx(s); tx(","); num(z*BPW); nl();
	end
	else do
		pr(".comm\t"); tx(s); tx(","); num(BPW); nl();
	end
	totext();
end


cg_loadglob(s, a, n) do
	ie (n)
		pr("movl\t$");
	else
		pr("movl\t");
	tx(s); tx(",%eax"); nl();
	push();
end


cg_loadlocl(a, n) do
	ie (n) do
		pr("movl\t$"); num(-a*BPW);
		tx(",%eax"); nl();
		pr("addl\t%ebp,%eax"); nl();
	end
	else do
		pr("movl\t"); num(-a*BPW); tx("(%ebp),%eax"); nl();
	end
	push();
end


cg_indirect() do
	pop();
	pr("movl\t(%eax),%eax"); nl();
	push();
end


cg_deref(lval) do
	pop2();
	pop();
	pr("shll\t$2,%ecx"); nl();	! BPW = 4 !
	pr("addl\t%ecx,%eax"); nl();
	if (\lval) do
		pr("movl\t(%eax),%eax"); nl();
	end
	push();
end


cg_saveglob(s, a) do
	pop();
	pr("movl\t%eax,"); tx(s); nl();
end


cg_savelocl(a) do
	pop();
	pr("movl\t%eax,"); num(-a*BPW); tx("(%ebp)"); nl();
end


cg_storevec() do
	pop2();
	pop();
	pr("movl\t%ecx,(%eax)"); nl();
end


cg_stack(n) do
	if (n) do
		pr("subl\t$"); num(n*BPW); tx(",%esp"); nl();
	end
end


cg_unstack(n) do
	if (n) do
		pr("addl\t$"); num(n*BPW); tx(",%esp"); nl();
	end
end


cg_call(s, a, n) do
	pr("call\t"); tx(s); nl();
	cg_unstack(n);
	push();
end


cg_numlit(n) do
	pr("movl\t$"); num(n);
	tx(",%eax"); nl();
	push();
end


cg_strlit(s) do
	var	i, l, k;

	k := length(s);
	todata();
	l := newlab();
	lab(l);
	tx(":\t.long\t");
	for (i=0, k) do
		if (i /\ \(i mod 10)) do
			nl();
			pr(".long\t");
		end
		num(s[i]);
		if (i mod 10 \= 9) tx(",");
	end
	if (i /\ \(i mod 10)) tx(",");
	tx("0"); nl();
	totext();
	return l;
end


cg_loadlab(l) do
	pr("movl\t$"); lab(l); tx(",%eax"); nl();
	push();
end


cg_sveclit() do
	var	v;

	todata();
	v := newlab();
	lab(v);
	col();
	return v;
end


cg_vecmem(n, f) do
	ie (f)  do
		pr(".long\t"); lab(n); nl();
	end
	else do
		pr(".long\t"); num(n); nl();
	end
end


cg_eveclit() do
	totext();
end


cg_negate() do
	pop();
	pr("negl\t%eax"); nl();
	push();
end


cg_lognot() do
	pop();
	pr("negl\t%eax"); nl();
	pr("sbbl\t%eax,%eax"); nl();
	pr("notl\t%eax"); nl();
	push();
end


cg_binnot() do
	pop();
	pr("notl\t%eax"); nl();
	push();
end


op2(s) do
	pop2();
	pop();
	pr(s); tx("\t%ecx,%eax"); nl();
	push();
end


cg_multiply() do
	pop2();
	pop();
	pr("imull\t%ecx"); nl();
	push();
end


cg_divide() do
	pop2();
	pop();
	pr("cdq"); nl();
	pr("idivl\t%ecx"); nl();
	push();
end


cg_modulo() do
	pop2();
	pop();
	pr("cdq"); nl();
	pr("idivl\t%ecx"); nl();
	pr("pushl\t%edx"); nl();
end


cg_add() do
	op2("addl");
end


cg_subtract() do
	op2("subl");
end



cg_binand() do
	op2("andl");
end


cg_binor() do
	op2("orl");
end


cg_binxor() do
	op2("xorl");
end


cg_binshl() do
	pop2();
	pop();
	tx("shll\t%cl,%eax"); nl();
	push();
end


cg_binshr() do
	pop2();
	pop();
	tx("shrl\t%cl,%eax"); nl();
	push();
end


relop(rel) do
	var	y, n;

	y := newlab();
	n := newlab();
	pop2();
	pop();
	pr("cmpl\t%ecx,%eax"); nl();
	ie (rel = '<')
		pr("jl");
	else ie (rel = '>')
		pr("jg");
	else ie (rel = 'L')
		pr("jle");
	else ie (rel = 'G')
		pr("jge");
	else ie (rel = '=')
		pr("je");
	else ie (rel = '#')
		pr("jne");
	else do
		select(1, 2);
		writes("bad relation in relop()\n");
		halt;
	end
	pr(""); lab(y); nl();
	pr("xorl\t%eax,%eax"); nl();
	pr("jmp\t"); lab(n); nl();
	lab(y); tx(":\tmovl\t$1,%eax"); nl();
	lab(n); col(); nl();
	push();
end


cg_equ() do relop('='); end
cg_nequ() do relop('#'); end
cg_less() do relop('<'); end
cg_grtr() do relop('>'); end
cg_lteq() do relop('L'); end
cg_gteq() do relop('G'); end


cg_incrglob(s, a, v) do
	pr("addl\t$"); num(v); tx(","); tx(s); nl();
end


cg_incrlocl(a, v) do
	pr("addl\t$"); num(v); tx(","); num(-a*BPW); tx("(%ebp)"); nl();
end


cg_tcond(n, flags) do
	var	l;

	l := newlab();
	pop();
	pr("orl\t%eax,%eax"); nl();
	ie (flags)
		pr(flags=1-> "je\t": "jne\t");
	else
		pr("jne\t");
 	lab(l); nl();
	if (flags) push();
	pr("jmp\t"); lab(n); nl();
	lab(l); col(); nl();
end


cg_fcond(y, n) do
	pr("jmp\t"); lab(y); nl();
	lab(n); col(); nl();
end


cg_econd(y) do
	lab(y); col(); nl();
end


cg_forcond(step, e) do
	var	l;

	l := newlab();
	pop2();
	pop();
	pr("cmpl\t%ecx,%eax"); nl();
	pr(step>0-> "jl\t": "jg\t"); lab(l); nl();
	pr("jmp\t"); lab(e); nl();
	lab(l); col(); nl();
end


cg_jump(l) do
	pr("jmp\t"); lab(l); nl();
end


cg_mark(l) do
	lab(l); col(); nl();
end


cg_fnhdr(s, l) do
	tx(s); col(); nl();
	lab(l); col(); nl();
	pr("pushl\t%ebp"); nl();
	pr("movl\t%esp,%ebp"); nl();
end


cg_fnexit(r) do
	lab(r); col();
	pr("popl\t%ebp"); nl();
	pr("ret"); nl();
end


cg_genhalt() do
	pr("pushl\t$0"); nl();
	pr("call\t__exit"); nl();
end


cg_prologue() do
	initcg();
	tx("/*"); nl();
	tx(" *  Compiled by T 3r3t -- Copyright (C) 1997,1998 Nils M. Holm");
	nl();
	tx(" *  Code generated for GAS(i386)"); nl();
	tx(" */"); nl();
	totext();
	pr("call\t_LIBINIT"); nl();
	pr("jmp\tSTART"); nl();
end


cg_start() do
	tx("START:");
	pr("movl\t%esp,%ebp"); nl();
end


cg_epilogue() do
	cg_genhalt();
	endcg();
end

