!	SYMCOM -- Copyright (C) 1997,1998 Nils M. Holm
!	See t.t for details.
!
!	SYMCOM creates a DOS command (.COM) file from a symbolic
!	input file (_SYM) as created by TSYM, the symbolic back end
!	of the T compiler.
!
!	WARNING: I have written SYMCOM for my personal use, since
!	TASM and LINK take ages to finish on my single-floppy XT
!	laptop. It stronly depends on the DOSLIB file which contains
!	the RT support routines of T. DOSLIB is not in ANY standard
!	format. For the gory details, have a look at STAND.s.
!	The most important tools while writing SYMCOM where DEBUG
!	and OD. It has been `developed' under BSD using PCEMU to try
!	out the generated code.
!	The `memory model' is weird. The output of SYMCOM is in
!	.COM format, but it relocates DS,ES,SS at startup time.
!	It does not check for sufficient memory, but just remaps
!	the stack/data segments. If little memory is available,
!	the program may happily overwrite MCBs, TSRs and other
!	things one better shouldn't touch.
!	If you have a choice, DON'T USE SYMCOM! Use TASM/TLINK
!	or MASM/LINK to assemble and link T programs.

const	BPW = 2;

const	OTEXT = 1024;
const	ODATA = 2048;
const	COPYBUF=1025;
const	OFFSET=	256;
const	PATCH = 50;

const	BUFLEN	= 1025;
const	LSPACE	= 16384;

const	ILABEL='L', IPOP='x', IDECL='d', ILDG='g', ILDGV='V', ILDL='p',
	ILDLV='v', IIND='i', IDEREF='X', ISAVG='G', ISAVL='P', ISTORE='S',
	ISTACK='s', IUNSTK='u', ICALL='c', INUM='n', ISTR='$', ILDLAB='l',
	IDATA='D', INEG='_', ILNOT='\\', IBNOT='~', IMUL='*', IDIV='/',
	IMOD='m', IADD='+', ISUB='-', IBAND='&', IBOR='|', IBXOR='^',
	IBSHL='{', IBSHR='}', IEQU='=', INEQU='#', ILESS='<', IGRTR='>',
	ILTEQ='(', IGTEQ=')', IINCG='Z', IINCL='z', IBRF='b', IBRT='B',
	IJUMP='j', IUFOR='f', IDFOR='F', IHDR='r', IEND='R', IHALT='h',
	IINIT='T', IPUSH='!', INOP='.';

const	EOF=%1, NUMBER=0;

const	LID	= 0,
	LADDR	= 1,
	LCLSS	= 2,
	LLEN	= 3;
const	CTEXT	= 0,
	CDATA	= 1,
	CBSS	= 2;

var	Buffer[BUFLEN];
var	DBuf[BUFLEN], CBuf[BUFLEN];
var	Dt, Ct;
var	Labels[LSPACE];
var	Lt;
var	Bp, Ep, Pos;
var	Token;
var	Value;
var	Output;
var	Dtop, Ctop, Btop;
var	Datafile;


scan() do
	var	c, state, sign;

	state := 0;
	Value := 0;
	while (1) do
		if (Bp >= Ep) do
			Ep := reads(Buffer, BUFLEN-1);
			Bp := 0;
			if (\Ep) do
				Token := EOF;
				return EOF;
			end
		end
		c := Buffer[Bp];
		Bp := Bp+1;
		Pos := Pos+1;
		ie (\state) do
			ie ('0' <= c /\ c <= '9' \/ c = '%') do
				Value := c='%'-> 0: c-'0';
				state := 1;
				sign := c = '%';
			end
			else do
				Token := c;
				return c;
			end
		end
		else do
			ie ('0' <= c /\ c <= '9') do
				Value := Value * 10 + (c-'0');
			end
			else do
				Bp := Bp-1;
				Pos := Pos-1;
				Token := NUMBER;
				if (sign) Value := -Value;
				return NUMBER;
			end
		end
	end
end


length(s) do
	var	i;

	i := 0;
	while (s[i]) i := i+1;
	return i;
end


copy(s, d) do
	var	i;

	i := 0;
	while (s[i]) do
		d[i] := s[i];
		i := i+1;
	end
	d[i] := 0;
end


writecode(buf) do
	var	k;

	ie (\buf) do
		writes(Cbuf);
		Ct := 0;
	end
	else do
		k := length(buf);
		if (Ct + k >= BUFLEN) do
			writes(Cbuf);
			Ct := 0;
		end
		copy(buf, @Cbuf[Ct]);
		Ct := Ct+k;
	end
end


writedata(buf) do
	var	o, k;

	o := select(1, Datafile);
	ie (\buf) do
		writes(Dbuf);
		Dt := 0;
	end
	else do
		k := length(buf);
		if (Dt + k >= BUFLEN) do
			writes(Dbuf);
			Dt := 0;
		end
		copy(buf, @Dbuf[Dt]);
		Dt := Dt+k;
	end
	select(1, o);
end


report(msg) do
	var	ch[2];

	select(1, 2);
	writes("symcom: "); writes(msg);
	writes(" [P=");
	writes(ntoa(Pos, 0));
	writes(", T=");
	ch[0] := Token;
	ch[1] := 0;
	ie (Token = NUMBER)
		writes("NUMBER");
	else ie (Token = EOF)
		writes("EOF");
	else
		writes(ch);
	writes(", V=");
	writes(ntoa(Value, 0));
	writes("]");
	newline();
	erase("_DATA");
	erase("X.COM");
	halt;
end


find(l) do
	var	i;

	i := 0;
	while (i<Lt) do
		if (Labels[i+LID] = l) return Labels[i+LADDR];
		i := i+LLEN;
	end
	if (Output) report("undefined label");
	return 0;
end


mark(l, loc) do
	var	lab;

	if (Output) return 0;
	if (Lt + LLEN >= LSPACE) report("too many labels");
	lab := @Labels[Lt];
	Lt := Lt+LLEN;
	lab[LID] := l;
	lab[LADDR] := loc;
	lab[LCLSS] := CTEXT;
end


fixlabel(c) do
	var	lab;

	if (Output) return 0;
	lab := @Labels[Lt-LLEN];
	if (lab[LCLSS] \= CTEXT) return 0;
	lab[LADDR] := c=CDATA-> Dtop: Btop;
	lab[LCLSS] := c;
end


num() do
	scan();
	if (Token \= NUMBER) report("numeric parameter expected");
	return Value;
end


label() do
	scan();
	if (Token \= ILABEL) report("label expected");
	return find(num());
end


semi() do
	scan();
	if (Token \= ';') report("separator expected");
end


emit(code) do
	var	c, i, j, buf[16];

	i := 0;
	j := 0;
	while (code[i]) do
		c := code[i];
		buf[j] := ('0'<=c /\ c<='9'-> c-'0': c-'A'+10)*16;
		c := code[i+1];
		if (\c) report("bad code in emit()");
		buf[j] := buf[j] + ('0'<=c /\ c<='9'-> c-'0': c-'A'+10) | 256;
		j := j+1;
		i := i+2;
	end
	buf[j] := 0;
	if (Output) writecode(buf);
	Ctop := Ctop+j;
end


emitn(n) do
	var	buf[3];

	buf[0] := n & 255 | 256;
	buf[1] := n >> 8 | 256;
	buf[2] := 0;
	if (Output) writecode(buf);
	Ctop := Ctop+BPW;
end


emitr(l) emitn(l-Ctop-2);


emitd(n) do
	var	o, buf[3];

	buf[0] := n & 255 | 256;
	buf[1] := n >> 8 | 256;
	buf[2] := 0;
	if (Output) writedata(buf);
	Dtop := Dtop+BPW;
end


string() do
	var	i, k;

	fixlabel(CDATA);
	k := num();
	scan();
	if (Token \= '$') report("string data expected");
	for (i=0, k) do
		emitd(num());
		if (i<k-1) semi();
	end
	emitd(0);
end


push() emit("50");

pop() emit("58");

pop2() emit("59");


op2(o) do
	pop2();
	pop();
	emit(o);
	push();
end


relop(o) do
	pop2();
	pop();
	emit("3BC1");
	ie (o = IEQU) emit("7404");
	else ie (o = INEQU) emit("7504");
	else ie (o = ILESS) emit("7C04");
	else ie (o = IGRTR) emit("7F04");
	else ie (o = ILTEQ) emit("7E04");
	else ie (o = IGTEQ) emit("7D04");
	else report("bad opcode in relop()");
	emit("33C0EB03B80100");
	push();
end


pass() do
	var	ch[2], v;
	var	doinit;

	ch[1] := 0;
	doinit := 0;
	while (1) do
		scan();
		if (Token = EOF) leave;
		ie (Token = ILABEL) do
			mark(num(), Ctop);
		end
		else ie (Token = IPOP) do
			pop();
		end
		else ie (Token = IDECL) do
			fixlabel(CBSS);
			v := num();
			Btop := Btop + (v-> v: 1)*BPW;
		end
		else ie (Token = ILDG) do
			emit("A1");
			emitn(find(num()));
			push();
		end
		else ie (Token = ILDGV) do
			emit("B8");
			emitn(find(num()));
			push();
		end
		else ie (Token = ILDL) do
			emit("8B86");
			emitn(num()*BPW);
			push();
		end
		else ie (Token = ILDLV) do
			emit("B8");
			emitn(num()*BPW);
			emit("03C5");
			push();
		end
		else ie (Token = IIND) do
			pop();
			emit("8BF08B04");
			push();
		end
		else ie (Token = IDEREF) do
			pop2();
			pop();
			emit("D1E103C1");
			push();
		end
		else ie (Token = ISAVG) do
			pop();
			emit("A3");
			emitn(find(num()));
		end
		else ie (Token = ISAVL) do
			pop();
			emit("8986");
			emitn(num()*BPW);
		end
		else ie (Token = ISTORE) do
			pop2();
			pop();
			emit("8BF0890C");
		end
		else ie (Token = ISTACK) do
			emit("81EC");
			emitn(num()*BPW);
		end
		else ie (Token = IUNSTK) do
			emit("81C4");
			emitn(num()*BPW);
		end
		else ie (Token = ICALL) do
			emit("E8");
			emitr(label());
			semi();
			v := num();
			if (v) do
				emit("81C4");
				emitn(v*BPW);
			end
			push();
		end
		else ie (Token = INUM) do
			emit("B8");
			emitn(num());
			push();
		end
		else ie (Token = ISTR) do
			string();
		end
		else ie (Token = ILDLAB) do
			emit("B8");
			emitn(label());
			push();
		end
		else ie (Token = IDATA) do
			fixlabel(CDATA);
			scan();
			v := Value;
			if (Token = ILABEL) v := find(num());
			emitd(v);
		end
		else ie (Token = INEG) do
			pop();
			emit("F7D8");
			push();
		end
		else ie (Token = ILNOT) do
			pop();
			emit("F7D81BC0F7D0");
			push();
		end
		else ie (Token = IBNOT) do
			pop();
			emit("F7D0");
			push();
		end
		else ie (Token = IMUL) do
			pop2();
			pop();
			emit("F7E9");
			push();
		end
		else ie (Token = IDIV) do
			pop2();
			pop();
			emit("99F7F9");
			push();
		end
		else ie (Token = IMOD) do
			pop2();
			pop();
			emit("99F7F952");
		end
		else ie (Token = IADD) do
			op2("03C1");
		end
		else ie (Token = ISUB) do
			op2("2BC1");
		end
		else ie (Token = IBAND) do
			op2("23C1");
		end
		else ie (Token = IBOR) do
			op2("0BC1");
		end
		else ie (Token = IBXOR) do
			op2("33C1");
		end
		else ie (Token = IBSHL) do
			op2("D3E0");
		end
		else ie (Token = IBSHR) do
			op2("D3E8");
		end
		else ie (Token = IEQU) do
			relop(IEQU);
		end
		else ie (Token = INEQU) do
			relop(INEQU);
		end
		else ie (Token = ILESS) do
			relop(ILESS);
		end
		else ie (Token = IGRTR) do
			relop(IGRTR);
		end
		else ie (Token = ILTEQ) do
			relop(ILTEQ);
		end
		else ie (Token = IGTEQ) do
			relop(IGTEQ);
		end
		else ie (Token = IINCG) do
			emit("8106");
			emitn(find(num()));
			semi();
			emitn(num());
		end
		else ie (Token = IINCL) do
			emit("8186");
			emitn(num()*BPW);
			semi();
			emitn(num());
		end
		else ie (Token = IBRF) do
			pop();
			emit("0BC0");
			emit("7504");
		end
		else ie (Token = IBRT) do
			pop();
			emit("0BC0");
			emit("7404");
		end
		else ie (Token = IJUMP) do
			emit("E9");
			emitr(label());
		end
		else ie (Token = IUFOR) do
			pop2();
			pop();
			emit("3BC17C03");
		end
		else ie (Token = IDFOR) do
			pop2();
			pop();
			emit("3BC17F03");
		end
		else ie (Token = IHDR) do
			emit("558BEC");
		end
		else ie (Token = IEND) do
			emit("5DC3");
		end
		else ie (Token = IHALT) do
			emit("B8004CCD21");
		end
		else ie (Token = IPUSH) do
			emit("50");
		end
		else ie (Token = INOP) do
			emit("90");
		end
		else ie (Token = IINIT) do
			doinit := 2;
		end
		else ie (Token = NUMBER) do
			ie (doinit)
				report("input file version is past T3");
			else
				report("unexpected free number");
		end
		else do
			report("unknown symbol");
		end
		if (doinit) doinit := doinit - 1;
	end
end


pass1() do
	var	in;

	in := open("_SYM", 0);
	if (in = %1) report("cannot open input file: _SYM");
	select(0, in);
	Output := 0;
	pass();
	close(in);
end


copylib() do
	var	o, lib, i, len;
	var	buf[COPYBUF];

	lib := open("DOSLIB", 0);
	if (lib = %1) report("cannot open library: DOSLIB");
	o := select(0, lib);
	len := reads(buf, COPYBUF);
	for (i=0, COPYBUF-1) do
		ie (i>=len)
			buf[i] := 256;
		else
			buf[i] := buf[i] | 256;
	end
	buf[COPYBUF-1] := 0;
	Ctop := (Ctop+16)/16; 
	buf[PATCH] := Ctop & 255 | 256;
	buf[PATCH+1] := Ctop >> 8 | 256;
	writecode(buf);
	select(0, o);
end


gendata() do
	var	i, in, k;
	var	buf[COPYBUF];

	for (i=0, ODATA/16) emit("4C4942444154412E4C4942444154412E");
	in := open("_DATA", 0);
	if (in = %1) report("cannot reopen data file: _DATA");
	while (1) do
		k := reads(buf, COPYBUF-1);
		if (\k) leave;
		for (i=0, k) buf[i] := buf[i] | 256;
		buf[k] := 0;
		writecode(buf);
	end
	close(in);
	erase("_DATA");
end


pass2() do
	var	in, out;

	in := open("_SYM", 0);
	if (in = %1) report("cannot reopen input file: _SYM");
	select(0, in);
	out := open("X.COM", 1);
	if (out = %1) report("cannot create output file: X.COM");
	select(1, out);
	Datafile := open("_DATA", 1);
	if (Datafile = %1) report("cannot create data file: _DATA");
	copylib();
	Ctop := OTEXT+OFFSET;
	Dtop := ODATA;
	Btop := 0;
	Pos := 0;
	Output := 1;
	pass();
	emit("90");
	while (Ctop mod 16) emit("90");
	close(in);
	writedata(0);
	close(Datafile);
	gendata();
	writecode(0);
	close(out);
end


reorder() do
	var	i, l;

	for (i=0, Lt, LLEN) do
		l := @Labels[i];
		if (l[LCLSS] = CBSS) l[LADDR] := l[LADDR] + Dtop;
	end
	i := (Dtop >> 1) + (Btop >> 1) + (Ctop >> 1);
	if (i>32767-2048 \/ i<0) report("program size exceeds 64K");
end


init() do
	var	i;

	Bp := 0;
	Ep := 0;
	Pos := 0;
	Dtop := ODATA;
	Ctop := OTEXT+OFFSET;
	Btop := 0;
	Lt := 0;
	Ct := 0;
	Dt := 0;
	Token := 0;
	Value := 0;
	Output := 0;
	for (i=1, 12) mark(i, OFFSET+i*4);
end


writek(a, b, c) do
	var	n, k;

	n := a+b+c;
	ie (n > 32767 \/ n < 0) do
		writes(ntoa((a>>10) + (b>>10) + (c>>10) + 3, 0));
		writes("K");
	end
	else do
		writes(ntoa(n, 0));
	end
end


info() do
	select(1, 1);
	writes("Text="); writek(Ctop-OFFSET, 0, 0);
	writes(" Data="); writek(Dtop-ODATA, 0, 0);
	writes(" BSS="); writek(Btop, 0, 0);
	writes(" Total="); writek(Ctop-OFFSET, Dtop-ODATA, Btop);
	newline();
end


do
	init();
	pass1();
	reorder();
	pass2();
	info();
end

